DROP PROCEDURE IF EXISTS `Periodicka_faktura`;

CREATE DEFINER=`root`@`localhost` PROCEDURE `Periodicka_faktura`()
BEGIN

DECLARE $partner_id INT;
DECLARE $uhrada_id INT;
DECLARE $user_id INT;
DECLARE $poznamka VARCHAR(100);
DECLARE $splatnost INT;
DECLARE $datum_splatnosti DATE;
DECLARE $periodicka_id INT;
DECLARE $last_id INT;
DECLARE done INT DEFAULT 1;



DECLARE cursor1 CURSOR FOR SELECT periodicka_id, partner_id, uhrada_id, user_id, splatnost, poznamka 
							FROM smsklad_periodicka 
							WHERE (den = DAY(CURDATE()) AND perioda_id = 1)
							OR (den = DAY(CURDATE()) AND MONTH(CURDATE()) IN (3,6,9,12) AND perioda_id = 2)
							OR (den = DAY(CURDATE()) AND MONTH(CURDATE()) = MONTH(datum) AND perioda_id = 3);

DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 2;

OPEN cursor1;
read_loop: LOOP

FETCH cursor1 INTO $periodicka_id, $partner_id, $uhrada_id, $user_id, $splatnost, $poznamka; 

IF done=2 THEN
    LEAVE read_loop;
END IF;
    
	SET $datum_splatnosti = DATE_ADD(CURDATE(), INTERVAL $splatnost DAY);

	INSERT INTO faktura 
		  SELECT
			   NULL,
			   $partner_id,
			   0,
			   $user_id,
			   0,
               '',
               0,
               0,
			   1,                           
			   COALESCE(MAX(cislo),0)+1,
			   0,
			   0, 
			   CURDATE(),
			   $datum_splatnosti,
			   '0000-00-00',
               $datum_splatnosti,
         0,
			   NOW(),
			   $poznamka
		  FROM faktura
		  WHERE druh=1;
		  
	SET $last_id = LAST_INSERT_ID();
	 
	INSERT INTO faktura_rucna 
		SELECT NULL, 
			   $last_id,
			   mj_id,
			   user_id,
			   artikel,
			   cena,
			   mnozstvo,
			   dph,
			   NOW()
		FROM smsklad_periodicka_rucna
		WHERE periodicka_id = $periodicka_id;
    
END LOOP;
CLOSE cursor1;

END;