DROP PROCEDURE IF EXISTS `Odpis_zo_skladu`;

CREATE DEFINER=`root`@`localhost` PROCEDURE `Odpis_zo_skladu`(
	IN `$artikel_id` INT(11),
	IN `$mnozstvo` DECIMAL(20,3),
	IN `$predajcena` DECIMAL(15,2),
	IN `$typ` INT,
    IN `$pokladna` INT,
	IN `$SKLAD_ID` INT(3),
	IN `$USER_ID` INT(11),
	IN `$STOL_ID` INT(11)
)
BEGIN
DECLARE $miest INT;
DECLARE $miesto_id INT;
DECLARE $celkom INT;
DECLARE $id_dokladu INT;
DECLARE $uctovat INT;
DECLARE $uctovat_cena_priemer DECIMAL(17,4);
DECLARE $uctovat_cena_predaj DECIMAL(15,2);
DECLARE $uctovat_sadzba DECIMAL(4,2);
DECLARE $uct_dph_id INT;
DECLARE $zlava DECIMAL(15,2);
DECLARE $zasoba_id INT;
DECLARE $cena_priemer DECIMAL(17,4);
DECLARE $cena_predaj DECIMAL(15,2);
DECLARE $sadzba DECIMAL(4,2);
DECLARE $uct_id INT;
DECLARE $dph_id INT;
DECLARE $id_do INT;
DECLARE $kus_artikel_id INT;
DECLARE $kus_mnozstvo DECIMAL(20,6);
DECLARE $kus_cena_priemer DECIMAL(17,4);
DECLARE $kus_obsah DECIMAL(6,2);
DECLARE $kus_zostatok DECIMAL(20,6);
DECLARE $kus_nahradny_id INT;
DECLARE $kus_sadzba DECIMAL(4,2);
DECLARE $pocet DECIMAL(20,6);
DECLARE $nahradny_pocet DECIMAL(20,6);
DECLARE $nahr_obsah DECIMAL(6,2);
DECLARE done INT DEFAULT 1;
DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
    ROLLBACK;
END;

START TRANSACTION;
IF ($typ=0) THEN SET $miest=$STOL_ID;
ELSE SET $miest=0;
END IF;

IF ($typ=5) THEN
  IF EXISTS (SELECT uct_id FROM uctenka WHERE stav=5 AND user_id=$USER_ID LIMIT 1) THEN
    SELECT COUNT(uct_id), doklad_id, zlava INTO $celkom,$id_dokladu,$zlava FROM uctenka WHERE stav=5 AND user_id=$USER_ID GROUP BY doklad_id LIMIT 1;
  ELSE
    SET $celkom=0;
  END IF;
ELSEIF ($typ=0) THEN
  IF EXISTS (SELECT uct_id FROM uctenka WHERE stav=0 AND miesto_id=$STOL_ID GROUP BY doklad_id LIMIT 1) THEN
    SELECT COUNT(uct_id), doklad_id, zlava INTO $celkom, $id_dokladu, $zlava FROM uctenka WHERE stav=0 AND miesto_id=$STOL_ID GROUP BY doklad_id LIMIT 1;
  ELSE
    SET $celkom=0;
  END IF;
ELSEIF ($typ=99) THEN
	SET $id_dokladu = $STOL_ID;
    SELECT 1, miesto_id, 0, stav INTO $celkom,$miest,$zlava,$typ FROM uctenka WHERE doklad_id=$id_dokladu LIMIT 1;
END IF;

SELECT a.zasoba_id, a.cena_priemer, a.cena_predaj, a.uctovat_id, b.dph_id, b.sadzba INTO $zasoba_id,$cena_priemer,$cena_predaj,$uctovat,$dph_id,$sadzba
          FROM artikel a LEFT JOIN dph b ON a.dph_id = b.dph_id
          WHERE a.artikel_id = $artikel_id;
IF ($predajcena=0) THEN
    SET $predajcena=$cena_predaj;
END IF;

IF ($zasoba_id = 8) THEN
    SET $mnozstvo = -1 * ABS($mnozstvo);
END IF;


IF ($celkom>0) THEN
    INSERT INTO uctenka VALUES (NULL,$artikel_id,$miest,$id_dokladu,$dph_id,0,$predajcena,$mnozstvo,$sadzba,NOW(),'0000-00-00 00:00:00','',0,$typ,0,$USER_ID);
    SET $uct_id = LAST_INSERT_ID();
ELSE 
    INSERT INTO doklad SELECT NULL,0,0,$SKLAD_ID,0,$USER_ID,0,4,COALESCE(MAX(cislo),0)+1,0,0,$pokladna,'','',0,'','','','','',CURDATE(),0,NOW() FROM doklad WHERE druh IN (4,6);
    SET $id_dokladu = LAST_INSERT_ID();
    INSERT INTO uctenka VALUES(NULL,$artikel_id,$miest,$id_dokladu,$dph_id,0,$predajcena,$mnozstvo,$sadzba,NOW(),'0000-00-00 00:00:00','',0,$typ,0,$USER_ID);
    SET $uct_id = LAST_INSERT_ID();
END IF;


IF ($zasoba_id=7) THEN
     UPDATE uctenka SET print=1, pocet=1 WHERE uct_id=$uct_id;
 
     IF($typ=5) THEN
       SELECT COALESCE( MAX( a.uct_id ) , 0 ) INTO $id_do
            FROM uctenka a LEFT JOIN artikel b ON a.artikel_id = b.artikel_id
            WHERE b.zasoba_id=7 AND a.stav=5 AND a.user_id=$USER_ID AND a.uct_id < $uct_id ORDER BY a.uct_id DESC LIMIT 1;
       UPDATE uctenka a LEFT JOIN pohyb b ON b.uct_id = a.uct_id  
			SET a.zlava = $cena_predaj, b.zlava = $cena_predaj 
            WHERE a.stav=5 AND a.user_id=$USER_ID AND a.uct_id <= $uct_id AND a.uct_id > $id_do;
	
    ELSEIF ($typ=0) THEN
        SELECT COALESCE( MAX( a.uct_id ) , 0 ) INTO $id_do
            FROM uctenka a LEFT JOIN artikel b ON a.artikel_id = b.artikel_id
            WHERE b.zasoba_id=7 AND a.miesto_id=$STOL_ID AND a.uct_id < $uct_id AND a.stav=0 ORDER BY a.uct_id DESC LIMIT 1;
        UPDATE uctenka a LEFT JOIN pohyb b ON b.uct_id = a.uct_id 
			SET a.zlava = $cena_predaj, b.zlava = $cena_predaj 
            WHERE a.miesto_id=$STOL_ID AND a.stav=0 AND a.uct_id <=$uct_id AND a.uct_id > $id_do;
	ELSE
        SELECT COALESCE( MAX( a.uct_id ) , 0 ) INTO $id_do
            FROM uctenka a LEFT JOIN artikel b ON a.artikel_id = b.artikel_id
            WHERE b.zasoba_id=7 AND a.doklad_id=$id_dokladu AND a.uct_id < $uct_id ORDER BY a.uct_id DESC LIMIT 1;
        UPDATE uctenka a LEFT JOIN pohyb b ON b.uct_id = a.uct_id 
			SET a.zlava = $cena_predaj, b.zlava = $cena_predaj 
            WHERE a.doklad_id=$id_dokladu AND a.uct_id <=$uct_id AND a.uct_id > $id_do;
END IF;

ELSEIF ($zasoba_id=6) THEN
  BEGIN
    DECLARE cursor1 CURSOR FOR SELECT artikel_id,mnozstvo FROM kusovnik WHERE kus_id=$artikel_id;
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 2;
    
    IF EXISTS (SELECT kus_id FROM kusovnik WHERE kus_id=$artikel_id LIMIT 1) THEN
        OPEN cursor1;
        read_loop: LOOP
        FETCH cursor1 INTO $kus_artikel_id,$kus_mnozstvo;
        IF done=2 THEN
            LEAVE read_loop;
        END IF;
            SELECT a.nahradny_id,a.cena_priemer,a.obsah, COALESCE(SUM(b.mnozstvo),0) AS zostatok, c.sadzba
              INTO $kus_nahradny_id,$kus_cena_priemer,$kus_obsah,$kus_zostatok,$kus_sadzba
              FROM artikel a
              LEFT JOIN pohyb b
              ON a.artikel_id=b.artikel_id
              LEFT JOIN dph c
              ON a.dph_id = c.dph_id
              WHERE a.artikel_id=$kus_artikel_id
              GROUP BY a.artikel_id;
            SET $pocet = ROUND($kus_mnozstvo * $mnozstvo / $kus_obsah,3);
            IF ((abs($pocet) > $kus_zostatok) && $kus_zostatok >0 && $kus_nahradny_id!=0)THEN
                INSERT INTO pohyb SELECT NULL,$id_dokladu,$uct_id,$kus_artikel_id,$SKLAD_ID,0,$USER_ID,$kus_cena_priemer,0,-$kus_zostatok,$kus_sadzba,0,NOW(),'',0;
                SELECT obsah INTO $nahr_obsah FROM artikel WHERE artikel_id = $kus_nahradny_id;
                SET $nahradny_pocet = ROUND(($pocet + $kus_zostatok) * $nahr_obsah,3);
                INSERT INTO pohyb SELECT NULL,$id_dokladu,$uct_id,$kus_nahradny_id,$SKLAD_ID,0,$USER_ID,$kus_cena_priemer,0,$nahradny_pocet,$kus_sadzba,0,NOW(),'',0;
            ELSEIF ((abs($pocet) > $kus_zostatok) && $kus_zostatok <= 0 && $kus_nahradny_id!=0) THEN
                SELECT obsah INTO $nahr_obsah FROM artikel WHERE artikel_id = $kus_nahradny_id;
                SET $pocet = ROUND($kus_mnozstvo * $mnozstvo / $nahr_obsah,3);
                INSERT INTO pohyb SELECT NULL,$id_dokladu,$uct_id,$kus_nahradny_id,$SKLAD_ID,0,$USER_ID,$kus_cena_priemer,0,$pocet,$kus_sadzba,0,NOW(),'',0;
            ELSE
                INSERT INTO pohyb SELECT NULL,$id_dokladu,$uct_id,$kus_artikel_id,1,0,$USER_ID,$kus_cena_priemer,0,$pocet,$kus_sadzba,0,NOW(),'',0;
            END IF;
        END LOOP;
        CLOSE cursor1;
    END IF;
  END;

ELSE
    INSERT INTO pohyb SELECT NULL,$id_dokladu,$uct_id,$artikel_id,$SKLAD_ID,0,$USER_ID,$cena_priemer,$predajcena,-$mnozstvo,$sadzba,0,NOW(),'',0;
END IF;

IF ($uctovat != 0) THEN
	SELECT a.cena_priemer, a.cena_predaj,a.dph_id, b.sadzba INTO $uctovat_cena_priemer,$uctovat_cena_predaj,$uct_dph_id,$uctovat_sadzba
		FROM artikel a LEFT JOIN dph b ON a.dph_id = b.dph_id 
		WHERE a.artikel_id = $uctovat;
	INSERT INTO uctenka VALUES(NULL,$uctovat,$miest,$id_dokladu,$uct_dph_id,0,$uctovat_cena_predaj,$mnozstvo,$uctovat_sadzba,NOW(),'0000-00-00 00:00:00','',0,$typ,0,$USER_ID);
	INSERT INTO pohyb SELECT NULL,$id_dokladu,LAST_INSERT_ID(),$uctovat,$SKLAD_ID,0,$USER_ID,$uctovat_cena_priemer,$uctovat_cena_predaj,-$mnozstvo,$uctovat_sadzba,0,NOW(),'',0;
END IF;
COMMIT;
END;