DROP VIEW IF EXISTS pohl_dodaci;

CREATE 
    ALGORITHM = UNDEFINED 
    DEFINER = `root`@`localhost` 
    SQL SECURITY DEFINER
VIEW `pohl_dodaci` AS
    SELECT 
        `x`.`doklad_id` AS `doklad_id`,
        `x`.`partner_id` AS `partner_id`,
        `x`.`vernost_id` AS `vernost_id`,
        `x`.`sklad_id` AS `sklad_id`,
        `x`.`zmazany_id` AS `zmazany_id`,
        `x`.`user_id` AS `user_id`,
        `x`.`poukazka` AS `poukazka`,
        `x`.`druh` AS `druh`,
        `x`.`cislo` AS `cislo`,
        `x`.`dph` AS `dph`,
        `x`.`faktura` AS `faktura`,
        `x`.`dodaci` AS `dodaci`,
        `x`.`objednavka` AS `objednavka`,
        `x`.`doprava` AS `doprava`,
        `x`.`poznamka` AS `poznamka`,
        `x`.`u_datum` AS `u_datum`,
        `x`.`zlava` AS `zlava`,
        `x`.`datum` AS `datum`,
        `y`.`firma` AS `firma`,
        `z`.`sklad` AS `sklad`,
        `w`.`faktura_id` AS `faktura_id`,
        (SELECT 
                `a`.`cislo`
            FROM
                (`faktura` `a`
                JOIN `faktura_dodaci` `b`)
            WHERE
                ((`a`.`faktura_id` = `b`.`faktura_id`)
                    AND (`b`.`doklad_id` = `x`.`doklad_id`))
            LIMIT 1) AS `cfaktura`,
        (SELECT 
                `b`.`cislo`
            FROM
                ((`doklad` `a`
                JOIN `doklad` `b` ON ((`a`.`vernost_id` = `b`.`doklad_id`)))
                JOIN `uctenka` `c` ON ((`b`.`doklad_id` = `c`.`doklad_id`)))
            WHERE
                ((`c`.`stav` = 9)
                    AND (`a`.`doklad_id` = `x`.`doklad_id`))
            GROUP BY `b`.`doklad_id`
            LIMIT 1) AS `dodak`,
        (SELECT 
                `b`.`cislo`
            FROM
                ((`doklad` `a`
                JOIN `doklad` `b`)
                JOIN `uctenka` `c`)
            WHERE
                ((`a`.`vernost_id` = `b`.`doklad_id`)
                    AND (`b`.`doklad_id` = `c`.`doklad_id`)
                    AND (`c`.`stav` IN (1 , 6))
                    AND (`a`.`doklad_id` = `x`.`doklad_id`))
            GROUP BY `b`.`doklad_id`
            LIMIT 1) AS `pokladna`,
        (SELECT 
                `b`.`cislo`
            FROM
                (`doklad` `a`
                LEFT JOIN `doklad` `b` ON ((`a`.`vernost_id` = `b`.`doklad_id`)))
            WHERE
                ((`b`.`druh` = 2)
                    AND (`a`.`doklad_id` = `x`.`doklad_id`))
            GROUP BY `b`.`doklad_id`
            LIMIT 1) AS `vydajka`,
        (SELECT 
                (-(1) * COALESCE(SUM(ROUND((`a`.`mnozstvo` * ROUND((`a`.`predaj` - ((`a`.`predaj` * `a`.`zlava`) / 100)),
                                            2)),
                                    2)),
                            0)) AS `spolu`
            FROM
                (`pohyb` `a`
                JOIN `artikel` `b` ON ((`a`.`artikel_id` = `b`.`artikel_id`)))
            WHERE
                ((`a`.`doklad_id` = `x`.`doklad_id`)
                    AND (`b`.`zasoba_id` <> 7))) AS `total`,
        (SELECT 
                SUM(((`smsklad_dodaci_rucna`.`predaj` * `smsklad_dodaci_rucna`.`mnozstvo`) - ROUND((((`smsklad_dodaci_rucna`.`predaj` * `smsklad_dodaci_rucna`.`mnozstvo`) * `smsklad_dodaci_rucna`.`zlava`) / 100),
                            2))) AS `spolu`
            FROM
                `smsklad_dodaci_rucna`
            WHERE
                (`smsklad_dodaci_rucna`.`doklad_id` = `x`.`doklad_id`)) AS `rucne`
    FROM
        (((`doklad` `x`
        JOIN `cis_partneri` `y` ON ((`x`.`partner_id` = `y`.`partner_id`)))
        JOIN `smsklad_sklad` `z` ON ((`x`.`sklad_id` = `z`.`sklad_id`)))
        LEFT JOIN `faktura_dodaci` `w` ON ((`w`.`doklad_id` = `x`.`doklad_id`)))
    WHERE
        (`x`.`druh` = 3);