DROP VIEW IF EXISTS pohl_faktura_all;

CREATE 
    ALGORITHM = UNDEFINED 
    DEFINER = `root`@`localhost` 
    SQL SECURITY DEFINER
VIEW `pohl_faktura_all` AS
    SELECT 
        `a`.`faktura_id` AS `faktura_id`,
        `a`.`partner_id` AS `partner_id`,
        `a`.`uhrada_id` AS `uhrada_id`,
        `a`.`user_id` AS `user_id`,
        `a`.`ftext_id` AS `ftext_id`,
        `a`.`druh` AS `druh`,
        `a`.`cislo` AS `cislo`,
        `a`.`cena` AS `cena`,
        `a`.`zlava` AS `zlava`,
        `a`.`u_datum` AS `u_datum`,
        `a`.`d_splatnosti` AS `d_splatnosti`,
        `a`.`d_dodania` AS `d_dodania`,
        `a`.`platba` AS `platba`,
        `a`.`send` AS `send`,
        `a`.`datum` AS `datum`,
        `a`.`poznamka` AS `poznamka`,
        `b`.`firma` AS `firma`,
        `b`.`email` AS `email`,
        COALESCE(SUM(ROUND((`e`.`mnozstvo` * ROUND((`e`.`predaj` - ((`e`.`predaj` * `e`.`zlava`) / 100)),
                                2)),
                        2)),
                0) AS `spolu`
    FROM
        ((((`faktura` `a`
        JOIN `cis_partneri` `b` ON ((`a`.`partner_id` = `b`.`partner_id`)))
        LEFT JOIN `faktura_dodaci` `c` ON ((`a`.`faktura_id` = `c`.`faktura_id`)))
        LEFT JOIN `doklad` `d` ON ((`c`.`doklad_id` = `d`.`doklad_id`)))
        LEFT JOIN `smsklad_dodaci_rucna` `e` ON ((`e`.`doklad_id` = `d`.`doklad_id`)))
    WHERE
        (`a`.`druh` = 1)
    GROUP BY `a`.`faktura_id` 
    UNION ALL SELECT 
        `a`.`faktura_id` AS `faktura_id`,
        `a`.`partner_id` AS `partner_id`,
        `a`.`uhrada_id` AS `uhrada_id`,
        `a`.`user_id` AS `user_id`,
        `a`.`ftext_id` AS `ftext_id`,
        `a`.`druh` AS `druh`,
        `a`.`cislo` AS `cislo`,
        `a`.`cena` AS `cena`,
        `a`.`zlava` AS `zlava`,
        `a`.`u_datum` AS `u_datum`,
        `a`.`d_splatnosti` AS `d_splatnosti`,
        `a`.`d_dodania` AS `d_dodania`,
        `a`.`platba` AS `platba`,
        `a`.`send` AS `send`,
        `a`.`datum` AS `datum`,
        `a`.`poznamka` AS `poznamka`,
        `b`.`firma` AS `firma`,
        `b`.`email` AS `email`,
        (-(1) * COALESCE(SUM(ROUND((`e`.`mnozstvo` * ROUND((`e`.`predaj` - ((`e`.`predaj` * `e`.`zlava`) / 100)),
                                2)),
                        2)),
                0)) AS `spolu`
    FROM
        (((((`faktura` `a`
        JOIN `cis_partneri` `b` ON ((`a`.`partner_id` = `b`.`partner_id`)))
        LEFT JOIN `faktura_dodaci` `c` ON ((`a`.`faktura_id` = `c`.`faktura_id`)))
        LEFT JOIN `doklad` `d` ON ((`c`.`doklad_id` = `d`.`doklad_id`)))
        LEFT JOIN `pohyb` `e` ON ((`e`.`doklad_id` = `d`.`doklad_id`)))
        LEFT JOIN `artikel` `f` ON ((`f`.`artikel_id` = `e`.`artikel_id`)))
    WHERE
        ((`a`.`druh` = 1)
            AND (`f`.`zasoba_id` <> 7))
    GROUP BY `a`.`faktura_id` 
    UNION ALL SELECT 
        `a`.`faktura_id` AS `faktura_id`,
        `a`.`partner_id` AS `partner_id`,
        `a`.`uhrada_id` AS `uhrada_id`,
        `a`.`user_id` AS `user_id`,
        `a`.`ftext_id` AS `ftext_id`,
        `a`.`druh` AS `druh`,
        `a`.`cislo` AS `cislo`,
        `a`.`cena` AS `cena`,
        `a`.`zlava` AS `zlava`,
        `a`.`u_datum` AS `u_datum`,
        `a`.`d_splatnosti` AS `d_splatnosti`,
        `a`.`d_dodania` AS `d_dodania`,
        `a`.`platba` AS `platba`,
        `a`.`send` AS `send`,
        `a`.`datum` AS `datum`,
        `a`.`poznamka` AS `poznamka`,
        `b`.`firma` AS `firma`,
        `b`.`email` AS `email`,
        COALESCE(SUM((`g`.`cena` * `g`.`mnozstvo`)), 0) AS `spolu`
    FROM
        ((`faktura` `a`
        JOIN `cis_partneri` `b` ON ((`a`.`partner_id` = `b`.`partner_id`)))
        LEFT JOIN `faktura_rucna` `g` ON ((`a`.`faktura_id` = `g`.`faktura_id`)))
    WHERE
        (`a`.`druh` = 1)
    GROUP BY `a`.`faktura_id` 
    UNION ALL SELECT 
        `a`.`faktura_id` AS `faktura_id`,
        `a`.`partner_id` AS `partner_id`,
        `a`.`uhrada_id` AS `uhrada_id`,
        `a`.`user_id` AS `user_id`,
        `a`.`ftext_id` AS `ftext_id`,
        `a`.`druh` AS `druh`,
        `a`.`cislo` AS `cislo`,
        `a`.`cena` AS `cena`,
        `a`.`zlava` AS `zlava`,
        `a`.`u_datum` AS `u_datum`,
        `a`.`d_splatnosti` AS `d_splatnosti`,
        `a`.`d_dodania` AS `d_dodania`,
        `a`.`platba` AS `platba`,
        `a`.`send` AS `send`,
        `a`.`datum` AS `datum`,
        `a`.`poznamka` AS `poznamka`,
        `b`.`firma` AS `firma`,
        `b`.`email` AS `email`,
        COALESCE(SUM(ROUND((`i`.`pocet` * ROUND((`i`.`cena` - ((`i`.`cena` * `i`.`zlava`) / 100)),
                                2)),
                        2)),
                0) AS `spolu`
    FROM
        (((`faktura` `a`
        JOIN `cis_partneri` `b` ON ((`a`.`partner_id` = `b`.`partner_id`)))
        LEFT JOIN `faktura_uctenka` `h` ON ((`a`.`faktura_id` = `h`.`faktura_id`)))
        LEFT JOIN `uctenka` `i` ON (((`h`.`doklad_id` = `i`.`doklad_id`)
            AND ((SELECT 
                `artikel`.`zasoba_id` AS `zasoba_id`
            FROM
                `artikel`
            WHERE
                (`artikel`.`artikel_id` = `i`.`artikel_id`)) <> 7))))
    WHERE
        (`a`.`druh` = 1)
    GROUP BY `a`.`faktura_id` 
    UNION ALL SELECT 
        `a`.`faktura_id` AS `faktura_id`,
        `a`.`partner_id` AS `partner_id`,
        `a`.`uhrada_id` AS `uhrada_id`,
        `a`.`user_id` AS `user_id`,
        `a`.`ftext_id` AS `ftext_id`,
        `a`.`druh` AS `druh`,
        `a`.`cislo` AS `cislo`,
        `a`.`cena` AS `cena`,
        `a`.`zlava` AS `zlava`,
        `a`.`u_datum` AS `u_datum`,
        `a`.`d_splatnosti` AS `d_splatnosti`,
        `a`.`d_dodania` AS `d_dodania`,
        `a`.`platba` AS `platba`,
        `a`.`send` AS `send`,
        `a`.`datum` AS `datum`,
        `a`.`poznamka` AS `poznamka`,
        `b`.`firma` AS `firma`,
        `b`.`email` AS `email`,
        (-(1) * COALESCE(SUM(ROUND((`m`.`mnozstvo` * ROUND((`m`.`predaj` - ((`m`.`predaj` * `m`.`zlava`) / 100)),
                                2)),
                        2)),
                0)) AS `spolu`
    FROM
        (((((`faktura` `a`
        JOIN `cis_partneri` `b` ON ((`a`.`partner_id` = `b`.`partner_id`)))
        LEFT JOIN `faktura_servis` `k` ON ((`a`.`faktura_id` = `k`.`faktura_id`)))
        LEFT JOIN `doklad` `l` ON ((`k`.`doklad_id` = `l`.`doklad_id`)))
        LEFT JOIN `pohyb` `m` ON ((`l`.`doklad_id` = `m`.`doklad_id`)))
        LEFT JOIN `artikel` `n` ON ((`m`.`artikel_id` = `n`.`artikel_id`)))
    WHERE
        ((`a`.`druh` = 1)
            AND (`n`.`zasoba_id` <> 7))
    GROUP BY `a`.`faktura_id`;