DROP PROCEDURE IF EXISTS `Prepocitaj_priemer`;

CREATE DEFINER=`root`@`localhost` PROCEDURE `Prepocitaj_priemer`(
	IN `$typ` INT(11),
	IN `$premenna` INT(11)
)
BEGIN

-- typ: 1- prepocitaj vsetko, 2- konkreny artikel , 3- prepocitaj priemer na doklade
-- premenna pri typ 1 a premennej 0 zmaze najprv vsetky priemerne ceny, 2 artikel_id, pri 3 doklad_id 
DECLARE $artikel_id INT;
DECLARE $pohyb_id INT;
DECLARE $sumar DECIMAL(20,4);
DECLARE $sumarx DECIMAL(20,4);
DECLARE $mnozstvo DECIMAL(20,3);
DECLARE $cena_priemer DECIMAL(17,4);
DECLARE $cena DECIMAL(15,5);
DECLARE $druh INT;
DECLARE done INT DEFAULT 1;

DECLARE cursor1 CURSOR FOR SELECT a.pohyb_id, a.cena, b.artikel_id, c.druh
							FROM pohyb a INNER JOIN artikel b ON a.artikel_id = b.artikel_id
										 INNER JOIN doklad c ON a.doklad_id = c.doklad_id
							WHERE b.zasoba_id IN (1,2,3)
                            AND a.rucna = 0
                            AND c.druh <> 9
							ORDER BY a.artikel_id ASC, c.u_datum ASC;

DECLARE cursor2 CURSOR FOR SELECT a.pohyb_id, a.cena, b.artikel_id, c.druh
							FROM pohyb a INNER JOIN artikel b ON a.artikel_id = b.artikel_id
										 INNER JOIN doklad c ON a.doklad_id = c.doklad_id
							WHERE b.zasoba_id IN (1,2,3)
                            AND a.artikel_id = $premenna
                            AND a.rucna = 0
                            AND c.druh <> 9
                            AND YEAR(a.datum) = YEAR(CURDATE())
							ORDER BY c.u_datum ASC;

DECLARE cursor3 CURSOR FOR SELECT a.pohyb_id, a.cena, b.artikel_id, c.druh
							FROM pohyb a INNER JOIN artikel b ON a.artikel_id = b.artikel_id
										 INNER JOIN doklad c ON a.doklad_id = c.doklad_id
							WHERE b.zasoba_id IN (1,2,3)
                            AND c.doklad_id = $premenna
                            AND a.rucna = 0
                            AND c.druh <> 9
                            AND YEAR(a.datum) = YEAR(CURDATE())
							ORDER BY a.artikel_id ASC, c.u_datum ASC;

DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 2;

IF ($typ = 1) THEN
	IF ($premenna = 0) THEN
	UPDATE artikel SET cena_priemer=0;
	END IF;

	OPEN cursor1;
	read_loop: LOOP
	FETCH cursor1 INTO $pohyb_id, $cena, $artikel_id, $druh;
	IF done=2 THEN
		LEAVE read_loop;
	END IF;

	IF ($druh=1) THEN 
          SELECT COALESCE(ROUND((SUM(a.cena*a.mnozstvo)/SUM(a.mnozstvo)),4),0) INTO $sumarx
												FROM pohyb a INNER JOIN doklad b ON a.doklad_id=b.doklad_id 
												WHERE a.artikel_id=$artikel_id
												AND a.pohyb_id <= $pohyb_id  
												AND b.druh <> 9
                                                AND a.cena <> 0
												AND a.rucna = 0;

			UPDATE artikel SET cena_priemer = $sumarx WHERE artikel_id=$artikel_id;
			UPDATE pohyb SET cena = $sumarx WHERE artikel_id=$artikel_id AND pohyb_id <= $pohyb_id AND cena = 0;

    ELSE
		SELECT SUM(a.mnozstvo) INTO $sumar 
			FROM pohyb a INNER JOIN doklad b ON a.doklad_id=b.doklad_id   
			WHERE a.artikel_id=$artikel_id AND b.druh <> 9 AND a.rucna = 0 AND a.pohyb_id <= $pohyb_id;
		IF ($sumar < 0) THEN
			UPDATE pohyb SET cena = 0 WHERE pohyb_id = $pohyb_id;
        ELSE
			UPDATE pohyb SET cena = (SELECT cena_priemer FROM artikel WHERE artikel_id = $artikel_id) WHERE pohyb_id = $pohyb_id; 
		END IF;
   END IF; 

END LOOP;

CLOSE cursor1;

INSERT INTO smsklad_prepocet VALUES(NOW());

END IF;

IF ($typ = 2) THEN

	SELECT SUM(a.mnozstvo) INTO $sumar 
			FROM pohyb a INNER JOIN doklad b ON a.doklad_id=b.doklad_id   
			WHERE a.artikel_id = $premenna 
            AND b.druh <> 9 
            AND a.rucna = 0;
		IF ($sumar >= 0) THEN
			SELECT COALESCE(ROUND((SUM(a.cena*a.mnozstvo)/SUM(a.mnozstvo)),4),0) INTO $sumarx
				FROM pohyb a INNER JOIN doklad b ON a.doklad_id=b.doklad_id 
				WHERE a.artikel_id = $premenna
				AND b.druh <> 9
				AND a.cena <> 0
				AND a.rucna = 0;

			UPDATE artikel SET cena_priemer = $sumarx WHERE artikel_id = $premenna;
			UPDATE pohyb SET cena = $sumarx WHERE artikel_id = $premenna AND cena = 0;			
        ELSE
			UPDATE artikel SET cena_priemer = 0 WHERE artikel_id = $premenna;
		END IF;

END IF;

IF ($typ = 3) THEN

	OPEN cursor3;
	read_loop: LOOP
	FETCH cursor3 INTO $pohyb_id, $cena, $artikel_id, $druh;

	IF done=2 THEN

		LEAVE read_loop;

	END IF;



IF ($druh=1) THEN 
       SELECT COALESCE(ROUND((SUM(a.cena*a.mnozstvo)/SUM(a.mnozstvo)),4),0) INTO $sumarx
												FROM pohyb a INNER JOIN doklad b ON a.doklad_id=b.doklad_id 
												WHERE a.artikel_id=$artikel_id
												AND a.pohyb_id <= $pohyb_id  
												AND b.druh <> 9
												AND a.cena <> 0
												AND a.rucna = 0;

			UPDATE artikel SET cena_priemer = $sumarx WHERE artikel_id=$artikel_id;
			UPDATE pohyb SET cena = $sumarx WHERE artikel_id=$artikel_id AND pohyb_id <= $pohyb_id AND cena = 0;

    ELSE
		SELECT SUM(a.mnozstvo) INTO $sumar 
			FROM pohyb a INNER JOIN doklad b ON a.doklad_id=b.doklad_id   
			WHERE a.artikel_id=$artikel_id AND b.druh <> 9 AND a.rucna = 0 AND a.pohyb_id <= $pohyb_id;
		IF ($sumar < 0) THEN
			UPDATE pohyb SET cena = 0 WHERE pohyb_id = $pohyb_id;
        ELSE
			UPDATE pohyb SET cena = (SELECT cena_priemer FROM artikel WHERE artikel_id = $artikel_id) WHERE pohyb_id = $pohyb_id; 
		END IF;
    END IF; 

END LOOP;

CLOSE cursor3;

END IF;

IF ($typ = 4) THEN

	OPEN cursor2;
	read_loop: LOOP
	FETCH cursor2 INTO $pohyb_id, $cena, $artikel_id, $druh;

	IF done=2 THEN
		LEAVE read_loop;
	END IF;
    
IF ($druh=1) THEN 
      SELECT COALESCE(ROUND((SUM(a.cena*a.mnozstvo)/SUM(a.mnozstvo)),4),0) INTO $sumarx
												FROM pohyb a INNER JOIN doklad b ON a.doklad_id=b.doklad_id 
												WHERE a.artikel_id=$artikel_id
												AND a.pohyb_id <= $pohyb_id  
												AND b.druh <> 9
												AND a.cena <> 0
												AND a.rucna = 0;

			UPDATE artikel SET cena_priemer = $sumarx WHERE artikel_id=$artikel_id;
			UPDATE pohyb SET cena = $sumarx WHERE artikel_id=$artikel_id AND pohyb_id <= $pohyb_id AND cena = 0;

    ELSE
		SELECT SUM(a.mnozstvo) INTO $sumar 
			FROM pohyb a INNER JOIN doklad b ON a.doklad_id=b.doklad_id   
			WHERE a.artikel_id=$artikel_id AND b.druh <> 9 AND a.rucna = 0 AND a.pohyb_id <= $pohyb_id;
		IF ($sumar < 0) THEN
			UPDATE pohyb SET cena = 0 WHERE pohyb_id = $pohyb_id;
        ELSE
			UPDATE pohyb SET cena = (SELECT cena_priemer FROM artikel WHERE artikel_id = $artikel_id) WHERE pohyb_id = $pohyb_id; 
		END IF;
   END IF;

END LOOP;

CLOSE cursor2;

END IF;
END;