DROP PROCEDURE IF EXISTS `Vyroba_uloz`;

CREATE DEFINER=`root`@`localhost` PROCEDURE `Vyroba_uloz`(
IN `$partner_id` INT(11),
IN `$user_id` INT(11),
IN `$vyrc_id` INT(11)
)
BEGIN

DECLARE $id_dokladu INT;
DECLARE $artikel_id INT;
DECLARE $sadzba INT;
DECLARE $sklad INT;
DECLARE $cena_predaj DECIMAL(15,2);
DECLARE $cena_prijem DECIMAL(15,2);

START TRANSACTION;

SELECT a.artikel_id, a.sklad_id, c.sadzba  INTO $artikel_id, $sklad, $sadzba 
	FROM smsklad_vyroba a INNER JOIN artikel b ON a.artikel_id = b.artikel_id
						  INNER JOIN dph c ON c.dph_id = b.dph_id
	WHERE a.vyrc_id = $vyrc_id;

INSERT INTO doklad 
  SELECT
	   NULL,
	   $partner_id,
	   0,
	   $sklad,
	   0,
	   $user_id,
	   0,
	   1,                           
	   COALESCE(MAX(cislo),0)+1,
	   11,
       0,
       0,
       '',
       '',
       0,
	   '',
	   '',
	   '',
	   '',
	   (SELECT poznamka FROM smsklad_vyroba WHERE vyrc_id = $vyrc_id),
	   CURDATE(),
	   0,
	   NOW()
  FROM doklad
  WHERE druh=1;
  
SET $id_dokladu = LAST_INSERT_ID();

SELECT -1 * SUM(predaj / (dph  / 100 + 1) * mnozstvo - ROUND(predaj / (dph  / 100 + 1) * mnozstvo * zlava / 100,2)) INTO $cena_prijem 
	FROM smsklad_vyroba_pohyb 
    WHERE vyrc_id = $vyrc_id;
    
SET $cena_predaj = ROUND(($cena_prijem * ($sadzba  / 100 + 1)),2);

INSERT INTO pohyb 
	VALUES(NULL,
			$id_dokladu,
            0,
            $artikel_id,
            $sklad,
            0,
            $user_id,
            $cena_prijem,
            $cena_predaj,
            (SELECT mnozstvo FROM smsklad_vyroba WHERE vyrc_id = $vyrc_id),
            $sadzba,
            0,
            NOW(),
            '',
            0);
            
UPDATE smsklad_vyroba SET prijemka_id = $id_dokladu WHERE vyrc_id = $vyrc_id;

INSERT INTO doklad 
	  SELECT
		   NULL,
		   $partner_id,
		   0,
		   (SELECT sklad_id FROM smsklad_vyroba WHERE vyrc_id = $vyrc_id),
		   0,
		   $user_id,
		   0,
		   2,                           
		   COALESCE(MAX(cislo),0)+1,
		   12,
           0,
           0,
           '',
           '',
           0,
		   '',
		   '',
		   '',
		   '',
		   (SELECT poznamka FROM smsklad_vyroba WHERE vyrc_id = $vyrc_id),
		   CURDATE(),
		   0,
		   NOW()
	  FROM doklad
	  WHERE druh=2;
      
SET $id_dokladu = LAST_INSERT_ID();  
         
INSERT INTO pohyb
	SELECT
		NULL,
		$id_dokladu,
		0,
		artikel_id,
		sklad_id,
		0,
		$user_id,
		ROUND(predaj / (dph  / 100 + 1),4),
		predaj,
		mnozstvo,
		dph,
		0,
		NOW(),
		'',
        0
	FROM smsklad_vyroba_pohyb
    WHERE vyrc_id = $vyrc_id;

UPDATE smsklad_vyroba SET vydajka_id = $id_dokladu, stav = 1 WHERE vyrc_id = $vyrc_id;    
COMMIT;
END;